--------------------------------------------------------------------------------
-- Animation handler

local Animator = class {
  FREEZE = "freeze",
}

function Animator:init(patterns, starter)
  self.patterns = patterns or {}
  self:reset(starting or "default")
end

function Animator:reset(name)
  self.index = 1
  self.clock = 0
  if self.patterns[name] then
    self.current = name
    self.frame = self.patterns[name][1][1]
    self.length = self.patterns[name][1][2]
  else
    self.current = nil
    self.length = 0
    self.frame = nil
  end
end

function Animator:set(name)
  if self.current ~= name then self:reset(name) end
end

function Animator:update(dt)
  if (self.current) and (self.length ~= self.FREEZE) then
    self.clock = self.clock + dt
    if self.clock >= self.length then
      self.clock = self.clock - self.length
      self.index = (self.index % #self.patterns[self.current]) + 1
      self.frame = self.patterns[self.current][self.index][1]
      self.length = self.patterns[self.current][self.index][2]
    end
  end
end

function Animator:get()
  return self.frame
end

return Animator

